package psapplets;

import java.applet.*;
import java.awt.*;
import psplot.*;
import real.*;

class psInteractiveCanvas extends PlotCanvas {

	controlNode cn;
	RealPoint corner = new RealPoint(0.5, 0.5);

	public psInteractiveCanvas(Applet app, int w, int h) {
		super(app, w, h);
		double ht = 3;
		// preserve aspect ratio
		double wd = w*(ht/h);
		setCorners(-wd, -ht, wd, ht);
		cn = new controlNode(this, corner, Color.red);
	}
	
	boolean ready = true;
	
	public void draw() {
		ready = false;
		PlotPath p;
		p = new PlotPath(this);
		p.moveto(-corner.x, -corner.y);
		p.lineto( corner.x, -corner.y);
		p.lineto( corner.x,  corner.y);
		p.lineto(-corner.x,  corner.y);
		p.close();
		p.fill(Color.red);
		p.stroke(Color.black);
		cn.draw();
		ready = true;
	}

	boolean active = false;

	public boolean mouseDown(Event evt, int x, int y) {
		// if (x, y) inside a node set mouseState = MouseActive
		if (cn.contains(x, y)) {
			active = true;
		}
		return true;
	}

	public boolean mouseDrag(Event evt, int x, int y) {
		if (active && ready ) {
			RealPoint q = toRealPoint(x, y);
			corner.x = q.x; corner.y = q.y;
			cn.locate(q);
			repaint();
		}
		return true;
	}

	public boolean mouseUp(Event evt, int x, int y) {
		// set nodes inactive
		active = false;
		return true;
	}
}

public class psInteractiveApplet extends Applet {
	psInteractiveCanvas p;
	Thread th;
	
	public void init() {
		p = new psInteractiveCanvas(this, bounds().width, bounds().height);
		add(p);
		show();
	}
}
