package psplot;

import java.awt.*;
import java.util.Stack;

import real.*;
import psplot.*;

/* Each path is an array of segmentsa.
   Each segment is an array of coordinates.
   Stroking a path means drawing lines along the pieces.
   Filling it means turning each piece into a polygon. */
   
   class PathSegment {
   	Stack stack;
   	
   	public PathSegment () {
   		stack = new Stack();
   	}
   	
   	void add(Point P) {
   		stack.push(P);
   	}
   	
   	void add(int a, int b) {
 		stack.push(new Point(a, b));
   	}
   	
   	Point currentPoint() {
   		return((Point) stack.peek());
   	}
   	
   	int size() {
   		return(stack.size());
   	}
   	
   	Polygon toPolygon() {
   		int n = stack.size();
   		int x[] = new int[n];
   		int y[] = new int[n];
   		for (int i=0;i<n;i++) {
   			Point P = (Point) stack.elementAt(i);
   			x[i] = P.x;
   			y[i] = P.y;
   		}
   		return(new Polygon(x, y, n));
   	}
   	
   	int draw(Graphics g) {
   		int n = stack.size();
   		if (n > 0) {
   			Point P0 = (Point) stack.elementAt(0);
   			for (int i=1;i<n;i++) {
   				Point P1 = (Point) stack.elementAt(i);
   				g.drawLine(P0.x, P0.y, P1.x, P1.y);
   				P0 = P1;
   			}
   		}
  		return(n-1);
   	}
   	
   	void print() {
   		for (int i=0;i<size();i++) {
   			Point P = (Point) stack.elementAt(i);
   			System.out.println("(" + P.x + ", " + P.y + ")");
   		}
   	}
   	
   }

